/*  Template for Receiving program using Virtual Wire
    with a 433 MHz Rx module
 */
#include <VirtualWire.h>
#include <VWComm.h>
#define receive_pin 11
#define ledPin 13 // this is used for the example code 
String text = "test";
int i;
byte b;
float f;
String dt;

VWComm vmc; //initialize an instance of the class


void setup()
{
  // The following must be included
  vw_set_rx_pin(receive_pin);
  vw_setup(2000);  // Bits per sec
  vw_rx_start();       // Start the receiver PLL running
  // Put your set up code here ....
  Serial.begin(9600);
  Serial.println("Starting...");
}

void loop()
{
  // The following is an example
  dt = vmc.dataType();
  if (dt == "B") {
    b = vmc.readByte();
    Serial.print("Byte received: ");
    Serial.println(b);
  }
  else if (dt == "I") {
    i = vmc.readInt();
    Serial.print("Integer received: ");
    Serial.println(i);
  }
  else if (dt == "S") {
    text = vmc.readStr();
    Serial.print("String received: ");
    Serial.println(text);
  }
    else if (dt == "F") {
    f = vmc.readFloat();
    Serial.print("Float received: ");
    Serial.println(f,DEC);
  }
  else {
    Serial.println("Data type not recognised!");
  }
}

